config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :tasks do
    resources :notes, only: [:create], controller: 'tasks/notes'
  end
  resources :categories
  root 'tasks#index'
  #get '/', to: 'tasks#show',  constraints: lambda { |request| user_signed_in?(request) }
  #root to: redirect('/users/sign_in')
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/task.rb
# == Schema Information
#
# Table name: tasks
#
#  id          :bigint           not null, primary key
#  name        :string
#  description :text
#  due_date    :date
#  category_id :bigint           not null
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#  owner_id    :bigint           not null
#  code        :string
#
class Task < ApplicationRecord
  belongs_to :category
  belongs_to :owner, class_name: 'User'
  has_many :participating_users, class_name: 'Participant'
  has_many :participants, through: :participating_users, source: :user
  has_many :notes

  accepts_nested_attributes_for :participating_users, allow_destroy: true, reject_if: :all_blank

  validates :participating_users, presence: true
  validates :name, :description, presence: true
  validates :name, uniqueness: { case_sensitive: false }
  validate  :due_date_validity

  before_create :create_code
  after_create :send_email

  def due_date_validity
    return if due_date.blank?
    return if due_date > Date.today
    errors.add :due_date, I18n.t('task.errors.invalid_due_date')
  end

  def create_code
    self.code = "#{owner_id}#{Time.now.to_i.to_s(36)}#{SecureRandom.hex(8)}"
  end

  def send_email
    (participants + [owner]).each do |user|
      ParticipantMailer.with(user: user, task: self).new_task_email.deliver!
    end
  end
end

app/controllers/tasks/notes_controller.rb
class Tasks::NotesController < ApplicationController
    before_action :set_task
    def create
        @note = @task.notes.new(note_params)
        @note.user = current_user
        @note.save
    end

    private
    def note_params
        params.require(:note).permit(:body)
    end
    def set_task
        @task = Task.find(params[:task_id])
    end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  load_and_authorize_resource
  before_action :set_task, only: %i[ show edit update destroy ]

  # GET /tasks or /tasks.json
  def index
    @tasks = Task.joins(:participants).where(
      'owner_id = ? OR participants.user_id = ?',
      current_user.id,
      current_user.id
    ).group(:id)
  end

  # GET /tasks/1 or /tasks/1.json
  def show
  end

  # GET /tasks/new
  def new
    @task = Task.new
    @task.participating_users.build
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks or /tasks.json
  def create
    @task = Task.new(task_params)
    @task.owner = current_user
    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: "Task was successfully created." }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1 or /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: "Task was successfully updated." }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1 or /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: "Task was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def task_params
      params.require(:task).permit(
        :name,
        :description,
        :due_date,
        :category_id,
        participating_users_attributes: [
          :user_id,
          :role,
          :id,
          :_destroy
        ]
      )
    end
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/tasks/_form.html.haml
-# frozen_string_literal: true
-# f.association :category
-#  .participants
-# = f.simple_fields_for :participating_users do |g|
-#   = render 'participating_user_fields', f: g
-# = simple_form_for(@task) do |f|
-#   = f.error_notification
-#   = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

-#   .form-inputs
-#     = f.input :name
-#     = f.input :description
-#     = f.input :due_date
-#     = f.association :category
-#     #addParticipants
-#       = link_to_add_association f, :participating_users, 'data-association-insertion-node' => '.participants .participants-container', 'data-turbolinks' => false do
-#         agregar participante
-#     .participants
-#       = f.simple_fields_for :participating_users do |g|
-#         = render 'participating_user_fields', f: g
-#       .participants-container
-#   .form-actions
-#     = f.button :submit
= simple_form_for(@task) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  .form-inputs
    .row
      .col-sm-6
        = f.input :name, label: 'Nombre'
      .col-sm-3
        = f.input :due_date, as: :string, input_html: { type: :date }, label: 'Fecha de vencimiento'
      .col-sm-3
        = f.input :category_id, label: 'Categoría', as: :select, collection: Category.all, input_html: { class: 'selectize' }
    .row
      .col-sm-12
        = f.input :description
    #addParticipants
      %br
      %h3
        .uppercased-font{ style: 'display: inline-block;' } Participantes
        = link_to_add_association f, :participating_users, class: 'btn btn-info float-right', 'data-association-insertion-node' => '.participants .participants-container', 'data-turbolinks' => false do
          Agregar un participante
          .fa.fa-plus-circle
    .participants
      = f.simple_fields_for :participating_users do |g|
        = render 'participating_user_fields', f: g
      .participants-container
  .form-actions
    = f.button :submit, class: 'btn btn-info'

app/views/tasks/_participating_user_fields.html.haml
.nested-fields
  %hr
  .text-right
  .row
    .col-4
      = f.input :user_id, label: 'Usuario', as: :select, collection: User.all - [current_user], label_method: -> (u) { u.email }, input_html: { class: 'selectize responsible' }
    .col-4
      = f.input :role, label: 'Rol', as: :select, collection: Participant.roles, value_method: -> (r) { r[1] }, input_html: { class: 'selectize role' }
    .col-4.text-left
      .mt-2
      = link_to_remove_association f, class: 'btn btn-warning btn-sm btn-flat mt-4' do
        .fas.fa-trash

app/views/tasks/edit.html.haml
.tasks.edit-page
  .card
    .card-body
      %h2 Editando tarea
      = render 'form'
      = link_to t('common.show'), @task, class: 'btn-interaction'
      \|
      = link_to t('common.back'), tasks_path, class: 'btn-interaction'

app/views/tasks/index.html.haml
.tasks.index-page
  .display-4 Lista de Tareas
  %p.text-muted.mb-2 A continuación verás toda la lista de tareas creadas, podrás crear una nueva tarea, editarla o eliminarla si eres el creador de la misma
  .card.bg-gray
    .card-body.pb-2
      .tasks-container
        - @tasks.each do |task|
          .task-container
            .task-info
              .task-title
                %span.small= "[##{task.code}]"
                = task.name
                %span.task-category
                  = task.category.name
              .task-description= task.description
              .task-dates
                %b= task.owner.email
                = "creado el #{l task.created_at, format: :long} / vence el #{task.due_date}"
            .task-interactions
              .task-participants
                - task.participating_users.includes(:user).each do |participant|
                  .task-participant{ class: "task-participant--#{participant.role}" }
                    = image_tag "https://robohash.org/#{participant.user.email}?size=60x60", title: participant.user.email
              .task-actions
                .dropdown
                  %a#taskMenu{"aria-expanded" => "false", "aria-haspopup" => "true", "data-toggle" => "dropdown"}
                    .fas.fa-ellipsis-v
                  .dropdown-menu{"aria-labelledby" => "taskMenu"}
                    = link_to t('common.show'), task, class: 'dropdown-item'
                    = link_to t('common.edit'), edit_task_path(task), class: 'dropdown-item'
                    = link_to t('common.destroy'), task, :method => :delete, :data => { :confirm => t('common.are_you_sure') }, class: 'dropdown-item'

app/views/tasks/new.html.haml
.tasks.new-page
  .card
    .card-body
      %h2 Nueva Tarea

      = render 'form'

      = link_to t('common.back'), tasks_path, class: 'btn-interaction'

app/views/tasks/show.html.haml
.tasks.show-page
  .display-4.mt-3.mb-3
    = "Tarea"
    %span.small= "[#{@task.code}]"
  %h2 Información
  .card
    .card-body
      .table-responsive
        %table.table.table-striped.table-borderless
          %thead
            %tr
              %th Código
              %th Nombre
              %th Categoría
              %th Creador
          %tbody
            %tr
              %td= @task.code || '213r'
              %td= @task.name
              %td= @task.category.name
              %td= @task.owner.email
        %table.table.table-striped.table-borderless
          %thead
            %tr
              %th Descripción
          %tbody
            %tr
              %td.font-weight-light= @task.description
      .task-participants
        .task-participants-header
          .font-weight-bold.text-uppercase= 'Participantes'
        - @task.participating_users.includes(:user).each do |participant|
          .task-participant{ class: "task-participant--#{participant.role}" }
            = image_tag "https://robohash.org/#{participant.user.email}?size=60x60", title: participant.user.email
      = link_to t('common.edit'), edit_task_path(@task)
      \|
      = link_to t('common.back'), tasks_path
  %h2.mt-2.mb-2 Notas
  .notes-container
    .card
      .card-body
        - if @task.notes.exists?
          .notes
            - @task.notes.order(created_at: :asc).each do |note|
              .note-element
                = render 'tasks/notes/note', note: note
        - else
          .notes
        = simple_form_for Note.new, url: task_notes_path(task_id: @task.id), remote: true do |f|
          = f.input :body, label: false, placeholder: 'Escriba una nota', as: :string, input_html: { autocomplete: :off }